#if 0
typedef unsigned char cfg_u8;
typedef union {
    struct {
        cfg_u8 offset;
        cfg_u8 value;
    };
    struct {
        cfg_u8 command;
        cfg_u8 param;
    };
} cfg_reg;

#define CFG_META_SWITCH (255)
#define CFG_META_DELAY  (254)
#define CFG_META_BURST  (253)

/* Example C code */
/*
    // Externally implemented function that can write n-bytes to the device
    // PCM51xx and TAS5766 targets require the high bit (0x80) of the I2C register to be set on multiple writes.
    // Refer to the device data sheet for more information.
    extern int i2c_write(unsigned char *data, int n);
    // Externally implemented function that delays execution by n milliseconds
    extern int delay(int n);
    // Example implementation.  Call like:
    //     transmit_registers(registers_ch1, sizeof(registers_ch1)/sizeof(registers_ch1[0]));
    void transmit_registers(cfg_reg *r, int n)
    {
        int i = 0;
        while (i < n) {
            switch (r[i].command) {
            case CFG_META_SWITCH:
                // Used in legacy applications.  Ignored here.
                break;
            case CFG_META_DELAY:
                delay(r[i].param);
                break;
            case CFG_META_BURST:
                i2c_write((unsigned char *)&r[i+1], r[i].param);
                i +=  (r[i].param / 2) + 1;
                break;
            default:
                i2c_write((unsigned char *)&r[i], 1);
                break;
            }
            i++;
        }
    }
 */
#endif
const cfg_reg registers_ch1[] = {
#define CHECKSUM (0)

// -----------------------------------------------------------------------------
// Reset
// -----------------------------------------------------------------------------

// 	Page 0
    { 0x00, 0x00 },
// 	Book 0
    { 0x7f, 0x00 },
// 	Page 0
    { 0x00, 0x00 },

// 	Reset Device
    { 0x01, 0x01 },

// 	1mS Delay
    { CFG_META_DELAY, 0x01 },

// 	Test bits Page fd
    { 0x00, 0x00 },
    { 0x7f, 0x00 },
    { 0x00, 0xfd },
// 	Password
    { 0x0d, 0x0d },
    { 0x3a, 0xe4 },
    { 0x3b, 0xe4 },
	
// 	1mS Delay
    { CFG_META_DELAY, 0x01 },
    { 0x12, 0xc0 },
	{ 0x19, 0x80 },
    { 0x32, 0x49 },
    { 0x3f, 0x21 },
	{ 0x46, 0x1f },
    { 0x5f, 0xc1 },

// -----------------------------------------------------------------------------
// Begin Device Memory
// -----------------------------------------------------------------------------

// 	Book 0 Page 0 (0x00) Dump
    { 0x00, 0x00 },
    { 0x7f, 0x00 },
    { 0x00, 0x00 },
    { 0x04, 0xf2 },
    { 0x0a, 0x03 },
    { 0x14, 0x00 },
    { 0x32, 0x81 },
    { 0x34, 0x48 },//10V Maximum boost
    { 0x35, 0xb4 },
    { 0x38, 0x21 },
    { 0x3c, 0x7c },
    { 0x3e, 0x00 },
    { 0x40, 0xb6 },

// 	Book 0 Page 1 (0x01) Dump
    { 0x00, 0x00 },
    { 0x7f, 0x00 },
    { 0x00, 0x01 },
    { 0x08, 0x00 },
	{ 0x21, 0x08 },

// 	Book 0 Page 2
    { 0x00, 0x00 },
    { 0x7f, 0x00 },
    { 0x00, 0x02 },
    { 0x0c, 0x40 },
    { 0x0d, 0x00 },
    { 0x0e, 0x00 },
    { 0x0f, 0x00 },
    { 0x10, 0x03 },
    { 0x11, 0x93 },
    { 0x12, 0xc2 },
    { 0x13, 0x29 },
    { 0x14, 0x2d },
    { 0x15, 0x6a },
    { 0x16, 0x86 },
    { 0x17, 0x6f },
    { 0x18, 0x47 },
    { 0x19, 0x5c },
    { 0x1a, 0x28 },
    { 0x1b, 0xf6 },
    { 0x1c, 0x16 },
    { 0x1d, 0x66 },
    { 0x1e, 0x66 },
    { 0x1f, 0x66 },
    { 0x20, 0x34 },
    { 0x21, 0xcc },
    { 0x22, 0xcc },
    { 0x23, 0xcd },
    { 0x24, 0x10 },
    { 0x25, 0x00 },
    { 0x26, 0x00 },
    { 0x27, 0x00 },
    { 0x28, 0x2e },
    { 0x29, 0x66 },
    { 0x2a, 0x66 },
    { 0x2b, 0x66 },
    { 0x2c, 0x2b },
    { 0x2d, 0x33 },
    { 0x2e, 0x33 },
    { 0x2f, 0x33 },
    { 0x30, 0x7f },
    { 0x31, 0xfb },
    { 0x32, 0x54 },
    { 0x33, 0xff },
    { 0x34, 0x80 },
    { 0x35, 0x04 },
    { 0x36, 0xab },
    { 0x37, 0x01 },
    { 0x38, 0x7f },
    { 0x39, 0xf6 },
    { 0x3a, 0xa9 },
    { 0x3b, 0xfe },
    { 0x3c, 0x3f },
    { 0x3d, 0xff },
    { 0x3e, 0x66 },
    { 0x3f, 0xbf },
    { 0x40, 0x01 },
    { 0x41, 0x18 },
    { 0x42, 0x1d },
    { 0x43, 0x93 },
    { 0x44, 0x00 },
    { 0x45, 0x00 },
    { 0x46, 0x02 },
    { 0x47, 0xde },
    { 0x48, 0x02 },
    { 0x49, 0x46 },
    { 0x4a, 0xb4 },
    { 0x4b, 0xe4 },
    { 0x4c, 0xd6 },
    { 0x4d, 0x57 },
    { 0x4e, 0x0e },
    { 0x4f, 0x91 },
    { 0x50, 0x61 },
    { 0x51, 0x2b },
    { 0x52, 0x3e },
    { 0x53, 0x89 },
    { 0x54, 0x00 },
    { 0x55, 0x00 },
    { 0x56, 0x01 },
    { 0x57, 0xb7 },
    { 0x58, 0x08 },
    { 0x59, 0x09 },
    { 0x5a, 0xbc },
    { 0x5b, 0xc4 },
    { 0x5c, 0x01 },
    { 0x5d, 0xc9 },
    { 0x5e, 0x24 },
    { 0x5f, 0x92 },
    { 0x60, 0x00 },
    { 0x61, 0x12 },
    { 0x62, 0x49 },
    { 0x63, 0x25 },
    { 0x64, 0x00 },
    { 0x65, 0x20 },
    { 0x66, 0xc4 },
    { 0x67, 0x9c },
    { 0x6c, 0x00 },
    { 0x6d, 0x00 },
    { 0x6e, 0x11 },
    { 0x6f, 0x3a },
    { 0x70, 0x7f },
    { 0x71, 0xfb },
    { 0x72, 0x54 },
    { 0x73, 0xff },
    { 0x74, 0x80 },
    { 0x75, 0x04 },
    { 0x76, 0xab },
    { 0x77, 0x01 },
    { 0x78, 0x7f },
    { 0x79, 0xf6 },
    { 0x7a, 0xa9 },
    { 0x7b, 0xfe },
    { 0x7c, 0x72 },
    { 0x7d, 0x14 },
    { 0x7e, 0x82 },
    { 0x7f, 0xc0 },

// 	Book 0 Page 4
    { 0x00, 0x00 },
    { 0x7f, 0x00 },
    { 0x00, 0x04 },
    { 0x58, 0x00 },
    { 0x59, 0x00 },
    { 0x5a, 0x00 },
    { 0x5b, 0x64 },
    { 0x5c, 0x40 },
    { 0x5d, 0xbd },
    { 0x5e, 0xb7 },
    { 0x5f, 0xc0 },
    { 0x60, 0x39 },
    { 0x61, 0x80 },
    { 0x62, 0x00 },
    { 0x63, 0x00 },
    { 0x64, 0x2d },
    { 0x65, 0x6a },
    { 0x66, 0x86 },
    { 0x67, 0x6f },
    { 0x68, 0x02 },
    { 0x69, 0x46 },
    { 0x6a, 0xb4 },
    { 0x6b, 0xe4 },

// 	Book 100 Page 7
    { 0x00, 0x00 },
    { 0x7f, 0x64 },
    { 0x00, 0x07 },
    { 0x38, 0x2f },
    { 0x39, 0x33 },
    { 0x3a, 0x33 },
    { 0x3b, 0x33 },
    { 0x3c, 0x00 },
    { 0x3d, 0x00 },
    { 0x3e, 0x00 },
    { 0x3f, 0x00 },
    { 0x40, 0x04 },
    { 0x41, 0xcc },
    { 0x42, 0xcc },
    { 0x43, 0xcd },
	
// 	Headroom changed to 1.5V
    { 0x48, 0x18 },
    { 0x49, 0x00 },
    { 0x4a, 0x00 },
    { 0x4b, 0x00 },

//  Hysterisis around Boost On threshold
    { 0x4c, 0x00 },
    { 0x4d, 0x00 },
    { 0x4e, 0x00 },
    { 0x4f, 0x00 },

//	Book 100 Page 8
    { 0x00, 0x00 },
    { 0x7f, 0x64 },
    { 0x00, 0x08 },
    { 0x1c, 0x60 },
    { 0x1d, 0x3b },
    { 0x1e, 0x01 },
    { 0x1f, 0xc0 },

//	Book 100 Page 18
    { 0x00, 0x00 },
    { 0x7f, 0x64 },
    { 0x00, 0x12 },
    { 0x10, 0x1e },
    { 0x11, 0x2e },
    { 0x12, 0x14 },
    { 0x13, 0x7b },
    { 0x14, 0x21 },
    { 0x15, 0x3d },
    { 0x16, 0x70 },
    { 0x17, 0xa4 },
    { 0x18, 0x24 },
    { 0x19, 0x4c },
    { 0x1a, 0xcc },
    { 0x1b, 0xcd },
    { 0x1c, 0x27 },
    { 0x1d, 0x5c },
    { 0x1e, 0x28 },
    { 0x1f, 0xf6 },
    { 0x20, 0x2a },
    { 0x21, 0x6b },
    { 0x22, 0x85 },
    { 0x23, 0x1f },
    { 0x24, 0x2d },
    { 0x25, 0x7a },
    { 0x26, 0xe1 },
    { 0x27, 0x48 },
    { 0x28, 0x30 },
    { 0x29, 0x8a },
    { 0x2a, 0x3d },
    { 0x2b, 0x71 },
    { 0x2c, 0x33 },
    { 0x2d, 0x99 },
    { 0x2e, 0x99 },
    { 0x2f, 0x9a },
    { 0x30, 0x36 },
    { 0x31, 0xa8 },
    { 0x32, 0xf5 },
    { 0x33, 0xc3 },
    { 0x34, 0x39 },
    { 0x35, 0xb8 },
    { 0x36, 0x51 },
    { 0x37, 0xec },
    { 0x38, 0x3c },
    { 0x39, 0xc7 },
    { 0x3a, 0xae },
    { 0x3b, 0x14 },
    { 0x3c, 0x3f },
    { 0x3d, 0xd7 },
    { 0x3e, 0x0a },
    { 0x3f, 0x3d },
    { 0x50, 0x1c },
    { 0x51, 0x94 },
    { 0x52, 0x7a },
    { 0x53, 0xe1 },
    { 0x54, 0x1f },
    { 0x55, 0xa3 },
    { 0x56, 0xd7 },
    { 0x57, 0x0a },
    { 0x58, 0x22 },
    { 0x59, 0xb3 },
    { 0x5a, 0x33 },
    { 0x5b, 0x33 },
    { 0x5c, 0x25 },
    { 0x5d, 0xc2 },
    { 0x5e, 0x8f },
    { 0x5f, 0x5c },
    { 0x60, 0x28 },
    { 0x61, 0xd1 },
    { 0x62, 0xeb },
    { 0x63, 0x85 },
    { 0x64, 0x2b },
    { 0x65, 0xe1 },
    { 0x66, 0x47 },
    { 0x67, 0xae },
    { 0x68, 0x2e },
    { 0x69, 0xf0 },
    { 0x6a, 0xa3 },
    { 0x6b, 0xd7 },
    { 0x6c, 0x32 },
    { 0x6d, 0x00 },
    { 0x6e, 0x00 },
    { 0x6f, 0x00 },
    { 0x70, 0x35 },
    { 0x71, 0x0f },
    { 0x72, 0x5c },
    { 0x73, 0x29 },
    { 0x74, 0x38 },
    { 0x75, 0x1e },
    { 0x76, 0xb8 },
    { 0x77, 0x52 },
    { 0x78, 0x3b },
    { 0x79, 0x2e },
    { 0x7a, 0x14 },
    { 0x7b, 0x7b },
    { 0x7c, 0x3e },
    { 0x7d, 0x3d },
    { 0x7e, 0x70 },
    { 0x7f, 0xa4 },
	
//	PowerUp
    { 0x00, 0x00 },
    { 0x7f, 0x00 },
    { 0x00, 0x00 },
    { 0x02, 0x0c },
};
